untyped
global function ClassHUDInit

struct {
	string passive1 = ""
	string passive2 = ""
	bool thread_exists = false
} file

void function ClassHUDInit()
{
	AddCallback_OnPlayerLifeStateChanged( on_lifestate_changed )
	AddCallback_GameStateEnter( eGameState.Playing, on_enter_game )
	//AddCallback_PlayerClassChanged		() // i dont care enough to implement this
	
	on_enter_game() // force it on connect because i cba to do it properly
}

void function update_passive_vars ( entity player )
{
	file.passive1 = ""
	file.passive2 = ""
	
	if ( player == null || player != GetLocalClientPlayer() || !IsValid( player ) || !IsAlive( player ) )
		return
	
	PilotLoadoutDef modifiedLoadout = clone GetActivePilotLoadout( player )
	file.passive1 = modifiedLoadout.passive1
	file.passive2 = modifiedLoadout.passive2
}

void function on_lifestate_changed( entity player, int oldLifeState, int newLifeState )
{
	if ( player == null || player != GetLocalClientPlayer() || newLifeState != LIFE_ALIVE || player.IsTitan() || !IsAlive( player ) )
		return
	
	thread wait_until_spectating_stops( ) // i hate myself
}

void function wait_until_spectating_stops()
{
	while ( IsWatchingKillReplay() ) // why
	{
		WaitFrame()
	}
	
	
	WaitFrame() // one extra incase lifestate changes during the killcam so 2 threads arent started in one tick. in reality this is just me being lazy not wanting to patch this later if this is a bug
	
	if ( !IsAlive( GetLocalClientPlayer() ) )
		return
	
	start_classhud( GetLocalClientPlayer() )
}

void function on_enter_game()
{
	entity player = GetLocalClientPlayer()
	
	if ( player == null || player.IsTitan() || IsAlive( player ) )
		return
	
	start_classhud( player )
}

void function start_classhud( entity player )
{
	if ( file.thread_exists )
		return
	
	update_passive_vars( player )
	thread threaded_classhud_main()
}

void function threaded_classhud_main()
{
	file.thread_exists = true
	
	float icon_size = 73
	
	asset image1 			= ( GetItemImage_safe( file.passive1) != $"" ? GetItemImage_safe( file.passive1 ) : $"vgui/hud/empty" )
	vector relative_pos1 	= < 0.0, -1.0, -0 > // units < forward, right, up > relative to camera
	
	asset image2 			= ( GetItemImage_safe( file.passive2 ) != $"" ? GetItemImage_safe( file.passive2 ) : $"vgui/hud/empty" )
	vector relative_pos2 	= < 0.0, -1.0, -0.1 >
	
	
	string text 	= Localize(GetItemName_safe( file.passive1 )) + "\n\n" + Localize(GetItemName_safe( file.passive2 ))
	float font_size = 35.0
	vector text_pos = < 0.06, 0.485, 0 >
	vector color 	= < 0.5, 0.6, 1.0 > // roughly the color of the passive bgs
	float alpha 	= 0.6
	
	var rui_pas1 = CreateIcon( image1, icon_size, relative_pos1 )
	var rui_pas2 = CreateIcon( image2, icon_size, relative_pos2 )
	var rui_pas_text = CreateText( text, font_size, text_pos, color, alpha )
	
	float start_time = Time()
	while( Time() < start_time + 3 )
	{
		WaitFrame()
		RuiSetFloat3( rui_pas1, "pos", ViewToWorldPos( relative_pos1 ) )
		RuiSetFloat3( rui_pas2, "pos", ViewToWorldPos( relative_pos2 ) )
	}
	
	RuiDestroyIfAlive( rui_pas1 )
	RuiDestroyIfAlive( rui_pas2 )
	RuiDestroyIfAlive( rui_pas_text )
	
	file.thread_exists = false
}


asset function GetItemImage_safe( string item )
{
	if ( !ItemDefined( item ) )
		return $"vgui/hud/empty"
	
	return GetItemImage( item )
}

string function GetItemName_safe( string item )
{
	if ( !ItemDefined( item ) )
		return ""
	
	return GetItemName( item )
}

var function CreateIcon( asset image, float size, vector relative_pos )
{
	var rui = RuiCreate( $"ui/overhead_icon_generic.rpak", clGlobal.topoFullScreen, RUI_DRAW_HUD, 1 )
	RuiSetImage( rui, "icon", image )
	RuiSetFloat2( rui, "iconSize", < size, size, 0.0 > )
	RuiSetFloat3( rui, "pos", ViewToWorldPos( relative_pos ) )
	RuiSetBool( rui, "isVisible", true )
	RuiSetBool( rui, "pinToEdge", true )
	return rui
}
var function CreateText( string text, float size, vector pos, vector color, float alpha )
{
	var rui = RuiCreate( $"ui/cockpit_console_text_top_left.rpak", clGlobal.topoFullScreen, RUI_DRAW_HUD, 1 )
	//RuiSetInt		( rui, "maxLines", 		1 )
	//RuiSetInt		( rui, "lineNum", 		1 )
	RuiSetFloat2	( rui, "msgPos", 		pos )
	RuiSetString	( rui, "msgText", 		text )
	RuiSetFloat		( rui, "msgFontSize",	size )
	RuiSetFloat		( rui, "msgAlpha",		alpha )
	//RuiSetFloat	( rui, "thicken", 		0.0 )
	RuiSetFloat3	( rui, "msgColor",		color )
	return rui
}

vector function ViewToWorldPos( vector relative_pos )
{
	
    vector pos = GetLocalViewPlayer().CameraPosition()
    pos += GetLocalViewPlayer().GetViewVector() * relative_pos.x
	pos += GetLocalViewPlayer().GetViewRight() * relative_pos.y
	pos += GetLocalViewPlayer().GetViewUp() * relative_pos.z
	
	return pos

}